import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Comparator;
import java.util.Scanner;

public class Main {

	static class Employee {
		int timeStart, floor, timeLeft;

		public Employee(int timeStart, int floor) {

			this.timeStart = timeStart;
			this.floor = floor;
		}

	}

	static class Floor {
		ArrayList<Employee> people = new ArrayList<>();
		boolean isActive;
	}

	public static void alreadyExist(ArrayList<Integer> al, int fl) {
		for (int i : al) {
			if (i == fl) {
				return;
			}
		}
		al.add(fl);
	}

	public static <T> void addArray(ArrayList<T> al1, ArrayList<T> al2) {
		for (T e : al2) {
			al1.add(e);
		}
	}

	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		int n = sc.nextInt();
		int m = sc.nextInt();
		ArrayList<Employee> al = new ArrayList<>();
		Employee arr[] = new Employee[n];
		for (int i = 0; i < n; i++) {
			al.add(new Employee(sc.nextInt(), sc.nextInt() - 1));
			arr[i] = al.get(i);
		}
		Floor[] floors = new Floor[m];
		for (int i = 0; i < m; i++) {
			floors[i] = new Floor();
		}
		int currentFloor = 0;
		int time = 0;
		int currentPoint = -1;
		ArrayList<Employee> notActive = new ArrayList<>();
		addArray(notActive, al);
		ArrayList<Employee> inLift = new ArrayList<>();
		ArrayList<Integer> orders = new ArrayList<>();
		int notOrdered = n;

		while (!al.isEmpty()) {
			if (notOrdered != 0) {
				while (time == notActive.get(0).timeStart) {
					Employee em = notActive.get(0);
					floors[em.floor].isActive = true;
					floors[em.floor].people.add(em);
					alreadyExist(orders, em.floor);
					notActive.remove(0);
					notOrdered--;
					if (notActive.isEmpty())
						break;
				}
			}
			if (currentFloor == 0) {
				if (!inLift.isEmpty()) {
					while (!inLift.isEmpty()) {
						inLift.get(0).timeLeft = time;
						al.remove(inLift.get(0));
						inLift.remove(0);
					}

					currentPoint = -1;
				}
				if (orders.isEmpty()) {
					time++;
				} else {
					currentPoint = orders.get(0);
					orders.remove(0);
					floors[currentPoint].isActive = true;
					currentFloor++;
					time++;
				}

			} else {
				if (currentPoint != 0) {
					if (currentFloor == currentPoint) {
						floors[currentFloor].isActive = false;
						for (Employee em : floors[currentPoint].people) {
							inLift.add(em);
						}

						floors[currentFloor].people.clear();
						currentFloor--;
						currentPoint = 0;
						time++;
					} else {
						currentFloor++;
						time++;
					}
				} else {
					if (floors[currentFloor].isActive) {
						floors[currentFloor].isActive = false;
						for (Employee em : floors[currentFloor].people) {
							inLift.add(em);
						}

						floors[currentFloor].people.clear();
						currentFloor--;
						currentPoint = 0;
						time++;
						for (int i = 0; i < orders.size(); i++) {
							if (orders.get(i) == currentFloor) {
								orders.remove(i);
								break;
							}
						}
					} else {
						currentFloor--;
						time++;

					}
				}
			}
		}
		for (Employee emp : arr) {
			System.out.println(emp.timeLeft);
		}

	}

}
