import java.util.Scanner;

public class Main {
	static class Node {
		int parent;
		long height;
		long height2;

		public Node(int height, int parent) {
			this.height = height;
			this.parent = parent;
		}
	}

	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		int n = sc.nextInt();
		long m = sc.nextLong();
		Node[] arr = new Node[n];
		arr[0] = new Node(0, -1);
		for (int i = 1; i < n; i++) {
			arr[i] = new Node(0, sc.nextInt() - 1);
		}
		for (int i = n - 1; i >= 1; i--) {
			Node parent = arr[(int) arr[i].parent];
			if (parent.height < arr[i].height + 1) {
				parent.height2 = parent.height;
				parent.height = arr[i].height + 1;
			} else {
				if (parent.height2 < arr[i].height + 1) {
					parent.height2 = arr[i].height + 1;
				}
			}
		}
		long max = 0;
		int maxNum = 0;
		for (int i = 0; i < n; i++) {
			if (max < arr[i].height + arr[i].height2) {
				max = arr[i].height + arr[i].height2;
				maxNum = i;
			}
		}

		long way = 2 * (arr[0].height) * (m - 1) + 2 * (m - 1) + arr[maxNum].height + arr[maxNum].height2 + 1;

		System.out.println(way);

	}

}
